# Hyper3D Rodin API

> PBR या शेडेड मटेरियल और क्वालिटी टियर के साथ टेक्स्ट या इमेज से Rodin 3D निर्माण

अधिकतम 1024 वर्णों वाले प्रॉम्प्ट, इनपुट इमेज या दोनों से 3D मॉडल बनाता है। बहु-इमेज इनपुट के लिए `condition_mode` fuse या concat होता है। विकल्पों में extra-low से high तक `quality`, PBR या Shaded `material`, Regular या Sketch `tier`, `TAPose`, `bbox_condition`, और glb, usdz, fbx, obj या stl एक्सपोर्ट शामिल हैं।

- Model id: `hyper3d/rodin`
- Made by: Hyper3D
- Category: Image to 3D
- Output: 3d
- Price: $0.40 / request (cheapest run $0.40 (400 API credits))
- Run: `POST https://api.doitong.com/v1/run/hyper3d/rodin`
- Quote: `POST https://api.doitong.com/v1/quote/hyper3d/rodin`
- Docs page: https://doitong.com/hi/developers/models/hyper3d/rodin

## Pricing

Price: **$0.40 / request**. Billed once per request.

The full example input below costs $0.40 = 400 API credits (1 request × 400 API credits).

Prices are the upstream price in USD, paid from the API balance in API credits (1000 API credits = 1 USD). `POST https://api.doitong.com/v1/quote/hyper3d/rodin` with the same JSON body returns the exact price for that input; the quote is exactly what a run charges. Invalid input is never charged and failed or canceled requests are refunded automatically.

## Input parameters

| Parameter | Canonical name | Type | Required | Default | Allowed values / range | Description |
|---|---|---|---|---|---|---|
| `prompt` |  | string | no | `` | ≤ 1024 characters | टेक्स्ट के रूप में दिया गया निर्माण मार्गदर्शन, जिसे Text-to-3D mode में आवश्यक है, लेकिन Image-to-3D mode में छोड़ा जा सकता है। |
| `input_image_urls` |  | array of image URL | no |  |  | स्रोत इमेज URL, जिन्हें Image-to-3D के लिए आवश्यक है और Text-to-3D मॉडल बनाने के लिए वैकल्पिक रूप से उपयोग कर सकता है। |
| `condition_mode` |  | enum (string) | no | `concat` | `fuse`, `concat` | इमेज conditioning विधि: concat एक ऑब्जेक्ट के कई दृश्यों से मॉडल बनाता है, जिसमें अपलोड का कोई निश्चित क्रम आवश्यक नहीं है। वैकल्पिक रूप से, fuse के लिए एक या अधिक इमेज आवश्यक हैं और यह ऑब्जेक्ट की विशेषताएँ निकालकर तथा इमेज के बीच उन्हें संयोजित करके मॉडल बनाता है। |
| `seed` |  | integer \| null | no |  | 0 – 65,535 | 0–65535 की सीमा वाला वैकल्पिक रैंडमाइज़ेशन seed। |
| `geometry_file_format` |  | enum (string) | no | `glb` | `glb`, `usdz`, `fbx`, `obj`, `stl` | ज्यामिति फ़ाइल फ़ॉर्मैट, glb, usdz, fbx, obj, stl में से चुना जाता है; डिफ़ॉल्ट glb है। |
| `material` |  | enum (string) | no | `PBR` | `PBR`, `Shaded` | मटेरियल चयन: PBR या Shaded, जिसमें PBR डिफ़ॉल्ट है। |
| `quality` |  | enum (string) | no | `medium` | `high`, `medium`, `low`, `extra-low` | निर्माण की गुणवत्ता का स्तर: high, medium, low, extra-low; डिफ़ॉल्ट medium है। |
| `use_hyper` |  | boolean | no | `false` |  | hyper-mode मॉडल एक्सपोर्ट को नियंत्रित करता है; डिफ़ॉल्ट false है। |
| `tier` |  | enum (string) | no | `Regular` | `Regular`, `Sketch` | निर्माण स्तर का चयन: Rodin Sketch के लिए Sketch या Rodin Regular के लिए Regular उपयोग करें। |
| `TAPose` |  | boolean | no | `false` |  | नियंत्रित करता है कि T/A pose में मानव-जैसा मॉडल बनाया जाए या नहीं। |
| `bbox_condition` |  | array of integer \| null | no |  |  | Bounding-box array, जो सामान्यतः 3 प्रविष्टियों में व्यवस्थित होती है: X-axis पर लंबाई, Y-axis पर चौड़ाई और Z-axis पर ऊँचाई। ये मान बॉक्स के आयाम और scaling factor निर्दिष्ट करते हैं। |
| `addons` |  | string \| null | no |  |  | वैकल्पिक निर्माण add-ons; डिफ़ॉल्ट [] है। उपलब्ध HighPack विकल्प high-poly मॉडल प्रदान करता है और texture रिज़ॉल्यूशन को डिफ़ॉल्ट 1K से 4K तक बढ़ाता है। |

File parameters (`input_image_urls`) take a public `https://` URL, a `data:` URI up to 10 MB, or the `file_url` of an upload from `POST /files`.

## Example input

Required parameters only:

```json
{}
```

A fuller example:

```json
{
  "prompt": ""
}
```

## Run it

Set `DOITONG_API_KEY` to a key from https://doitong.com/developers/dashboard#keys. `?wait=20` returns the finished request in the same call when it is ready within 20 seconds; otherwise poll `GET /requests/{id}` (it also accepts `?wait=`), or pass `webhook_url`.

### curl

```bash
# Run the model; wait up to 20 s for the finished result in the same call
curl -X POST "https://api.doitong.com/v1/run/hyper3d/rodin?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "prompt": ""
  }'

# Still "queued" or "running"? Poll with the id from the response:
curl "https://api.doitong.com/v1/requests/REQUEST_ID?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY"
```

### JavaScript

```javascript
const API = "https://api.doitong.com/v1";
const headers = {
  "Authorization": "Bearer " + process.env.DOITONG_API_KEY,
  "Content-Type": "application/json",
};

// Run the model; wait up to 20 s for the finished result in the same call
let res = await fetch(API + "/run/hyper3d/rodin?wait=20", {
  method: "POST",
  headers,
  body: JSON.stringify({
    "prompt": ""
  }),
});
let request = await res.json();
if (!res.ok) throw new Error(request.error.code + ": " + request.error.message);

// Not finished yet: long-poll until it is
while (request.status === "queued" || request.status === "running") {
  res = await fetch(API + "/requests/" + request.id + "?wait=20", { headers });
  request = await res.json();
}
if (request.status !== "succeeded") throw new Error(JSON.stringify(request.error));
console.log(request.outputs.map((o) => o.url), request.cost.credits + " API credits ($" + request.cost.usd + ")");
```

### Python

```python
import os
import requests

API = "https://api.doitong.com/v1"
headers = {"Authorization": "Bearer " + os.environ["DOITONG_API_KEY"]}

payload = {
    "prompt": "",
}

# Run the model; wait up to 20 s for the finished result in the same call
r = requests.post(API + "/run/hyper3d/rodin", params={"wait": 20}, json=payload, headers=headers)
request = r.json()
if not r.ok:
    raise RuntimeError(request["error"]["code"] + ": " + request["error"]["message"])

# Not finished yet: long-poll until it is
while request["status"] in ("queued", "running"):
    request = requests.get(API + "/requests/" + request["id"], params={"wait": 20}, headers=headers).json()
if request["status"] != "succeeded":
    raise RuntimeError(request["error"])
print([o["url"] for o in request["outputs"]], request["cost"]["credits"], "API credits", "$" + request["cost"]["usd"])
```

### MCP

The MCP server at `https://api.doitong.com/v1/mcp` exposes the tools `search_models`, `get_model`, `quote`, `run`, `get_request`, `cancel_request`, `list_requests`, `create_upload` and `get_account`. A `run` call for this model:

```json
{
  "jsonrpc": "2.0",
  "id": 1,
  "method": "tools/call",
  "params": {
    "name": "run",
    "arguments": {
      "model_id": "hyper3d/rodin",
      "input": {
        "prompt": ""
      },
      "wait_seconds": 20
    }
  }
}
```

## Response

Every call returns a request object. `status` is one of `queued`, `running`, `succeeded`, `failed`, `canceled`. `outputs` lists the generated files with URLs on our storage (kept forever, or 7 days with `?storage=temporary`; `storage` says which); `output` is the model's own result object with the same URLs.

```json
{
  "id": "req_8k2m4q7x1z9c3v5b6n0p2r4t",
  "object": "request",
  "model": "hyper3d/rodin",
  "status": "succeeded",
  "created_at": "2026-10-20T12:00:00Z",
  "started_at": "2026-10-20T12:00:02Z",
  "completed_at": "2026-10-20T12:00:09Z",
  "queue_position": null,
  "cost": {
    "credits": 400,
    "usd": "0.40",
    "charged": 400,
    "refunded": 0
  },
  "input": {
    "prompt": ""
  },
  "output": {
    "model_mesh": {
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_name": "0-output.jpeg",
      "file_size": 1843200
    },
    "seed": 42,
    "textures": [
      {
        "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
        "content_type": "image/jpeg",
        "file_name": "0-output.jpeg",
        "file_size": 1843200,
        "width": 1024,
        "height": 768
      }
    ]
  },
  "outputs": [
    {
      "type": "file",
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_size": 1843200,
      "stored": true
    }
  ],
  "error": null,
  "metrics": {
    "inference_seconds": 6.8
  },
  "urls": {
    "self": "https://api.doitong.com/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t",
    "cancel": "https://api.doitong.com/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t/cancel"
  }
}
```

### Output fields (`output`)

| Field | Type | Description |
|---|---|---|
| `model_mesh` | object {url, content_type, file_name, file_size} | निर्मित 3D ऑब्जेक्ट वाली फ़ाइल। |
| `seed` | integer | निर्माण के दौरान लागू किया गया seed। |
| `textures` | array of object {url, content_type, file_name, file_size, width, height} | 3D ऑब्जेक्ट के लिए बनाई गई textures। |

## Related models

- [Hyper3d](https://doitong.com/developers/models/hyper3d/rodin/v2.md) (`hyper3d/rodin/v2`): $0.40 / request
- [Hyper3D - Rodin V2.5 - Image to 3D](https://doitong.com/developers/models/hyper3d/rodin/v2.5.md) (`hyper3d/rodin/v2.5`): from $0.40 / request
- [Hyper3D - Rodin V2.5 - Image to 3D - Fast](https://doitong.com/developers/models/hyper3d/rodin/v2.5/fast.md) (`hyper3d/rodin/v2.5/fast`): $0.10 / request
- [Hi3D Image to 3D](https://doitong.com/developers/models/hitem3d/hi3d/image-to-3d.md) (`hitem3d/hi3d/image-to-3d`): $0.50 / run
- [Hi3D Image to 3D · v3.0](https://doitong.com/developers/models/hitem3d/hi3d/v3.0/image-to-3d.md) (`hitem3d/hi3d/v3.0/image-to-3d`): from $1.80 / run
- [Hi3D Multiview to 3D · Multi View to 3D](https://doitong.com/developers/models/hitem3d/hi3d/multi-view-to-3d.md) (`hitem3d/hi3d/multi-view-to-3d`): $0.50 / run
- [Hi3D Multiview to 3D · v3.0 · Multi View to 3D](https://doitong.com/developers/models/hitem3d/hi3d/v3.0/multi-view-to-3d.md) (`hitem3d/hi3d/v3.0/multi-view-to-3d`): from $1.80 / run
- [Hunyuan 3D Pro Image to 3D](https://doitong.com/developers/models/hunyuan-3d/v3.1/pro/image-to-3d.md) (`hunyuan-3d/v3.1/pro/image-to-3d`): $0.375 / run

## Links

- HTML page: https://doitong.com/developers/models/hyper3d/rodin
- All models and guides for AI agents: https://doitong.com/developers/llms.txt
- OpenAPI 3.1 with this model's typed request body: https://doitong.com/developers/openapi.json?model=hyper3d/rodin
- Errors: https://doitong.com/developers/docs/errors
- Model details as JSON: https://api.doitong.com/v1/models/hyper3d/rodin
